#include <stdlib.h>
#include <stdio.h>
#include "fftpert.h"


FILE* get_cfg(int argc, char *argv[])
{
  
  FILE *cfg;

  
  /* one possible parameter is the name of alternative config file */

  if (argc > 2)
    { 
      help();
      exit(1);
    }
  else if (argc == 2)
    {
     if ( (cfg = fopen(argv[1],"r")) == NULL )
       {
        printf("Specified configuration file %s is not found.\n",argv[1]);
        printf("Using %s ...\n",DEFAULT_CONFIG);
        if ( (cfg = fopen(DEFAULT_CONFIG,"r")) == NULL )
	  {
           printf("Default configuration file %s is not found. Exiting...\n",
                  DEFAULT_CONFIG);
           exit(2);
          }
        else
          {
           printf("Using configuration from %s\n",DEFAULT_CONFIG);
          }     
       }
     else
       {
        printf("Using configuration from %s\n",argv[1]);
       }     
    }
  else
    {
     if ( (cfg = fopen(DEFAULT_CONFIG,"r")) == NULL )
       {
        printf("Default configuration file %s is not found. Exiting...\n",
               DEFAULT_CONFIG);
        exit(3);
       }
     else
       {
        printf("Using configuration from %s\n",DEFAULT_CONFIG);
       }     
    }

  return(cfg);

} 

