#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include "fftpert.h"

void print_coeffs(fftw_complex* data, 
                  DOUBLE max_printed, DOUBLE boundary,
                  DOUBLE scale,
                  INT mode,
                  LINT fftI, LINT fftJ, LINT fftK, LINT fftL, LINT fftM)
{
  LINT i,j,k,l,m;
  LINT ci,cj,ck,cl,cm;
  LINT indI,indJ,indK,indL,indM;

  DOUBLE print_boundary;
  DOUBLE cur;
  LINT print_counter;

  printf("\n\nRequested coefficients:\n\n");

/* set boundary for the coefficients to be printed */
     max_printed = max_printed / scale;

     if (boundary > max_printed) 
       {
        print_boundary = boundary;
       }
     else
       {
        print_boundary = max_printed;
       }

/* initialize counter */
     print_counter=0;

  for (i=0; i < fftI; i++)
    {
     indI = fftJ * i;
     ci = (i > fftI/2) ? i-fftI : i;
     for (j=0; j < fftJ; j++)
       {
        indJ = fftK * ( j + indI );
        cj = (j > fftJ/2) ? j-fftJ : j;
        for (k=0; k < fftK; k++)          
	  {
           indK = fftL * ( k + indJ );
           ck = (k > fftK/2) ? k-fftK : k;
/* here we consider only the coefficients with the same parity of l and k */
/* for mode==2 l should be of the same parity as i+j+k */
/* for mode==3 l should be of the same parity as k */
           for (l=( (mode == 2) ? (i+j+k)%2 : k%2 ); l < fftL; l=l+2)
	     {
              indL = (fftM/2+1) * ( l + indK );
              cl = (l > fftL/2) ? l-fftL : l;
              for (m=0; m < fftM/2+1; m++)
		{
                 indM = m + indL;
                 cm=m;
/* any operations for data[indM] start here */

  cur = data[indM].re;

/* printing significant coefficients */
  if(fabs(cur) >= print_boundary)
    {
     printf(FORLINT" "FORLINT" "FORLINT" "FORLINT" "FORLINT" "FORDOUBLE"\n",ci,cj,ck,cl,cm,cur*scale);
     print_counter++;
    }

/* any operations for data[indM] end here */
		}
	     }
	  }
       }
    }

printf("\n\n "FORLINT" coefficients are larger the print boundary "FORDOUBLE"\n",
       print_counter,print_boundary*scale);

}








